#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
int global;

void* add50000(void* param) {
	int i,h;
	for(i = 0; i < 10; i++) {
		pthread_mutex_lock(&mutex);
		for(h = 0; h < 5000; h++) {
			global += 1;
		}
		pthread_cond_signal(&cond);
		pthread_mutex_unlock(&mutex);
		sleep(1);
	}
}

void* print_global(void* param) {
	while(global < 50000) {
		pthread_mutex_lock(&mutex);
		pthread_cond_wait(&cond, &mutex);
		printf("global=%d\n", global);
		pthread_mutex_unlock(&mutex);
	}
}
	

int main (int argc, char* argv[]) {
	global = 0;
	pthread_t thread[2];
	int t, rc;
	rc = pthread_create(&thread[0], NULL, add50000, NULL);
	if (rc){
		printf("ERROR; return code from pthread_create() is %d\n", rc);
		exit(-1);
	}
	rc= pthread_create(&thread[1], NULL, print_global, NULL);
	if (rc){
		printf("ERROR; return code from pthread_create() is %d\n", rc);
		exit(-1);
	}
	for(t=0; t<2; t++) {
		rc = pthread_join(thread[t], NULL);
		if (rc) {
			printf("ERROR; return code from pthread_join() is %d\n", rc);
			exit(-1);
		}
	}
}
